Index: source/simulation2/tests/test_ComponentManager.h
===================================================================
--- source/simulation2/tests/test_ComponentManager.h	(Revision 14461)
+++ source/simulation2/tests/test_ComponentManager.h	(Arbeitskopie)
@@ -59,14 +59,14 @@
 	void test_Load()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 	}
 
 	void test_LookupCID()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		TS_ASSERT_EQUALS(man.LookupCID("Test1A"), (int)CID_Test1A);
@@ -76,7 +76,7 @@
 	void test_AllocateNewEntity()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 
 		TS_ASSERT_EQUALS(man.AllocateNewEntity(), (u32)2);
 		TS_ASSERT_EQUALS(man.AllocateNewEntity(), (u32)3);
@@ -99,7 +99,7 @@
 	void test_AddComponent_errors()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		CEntityHandle hnd1 = man.AllocateEntityHandle(1);
 
@@ -122,7 +122,7 @@
 	void test_QueryInterface()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2;
@@ -147,7 +147,7 @@
 	void test_SendMessage()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2, ent3 = 3, ent4 = 4;
@@ -221,7 +221,7 @@
 	void test_ParamNode()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2;
@@ -242,7 +242,7 @@
 	void test_script_basic()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test.js"));
 
@@ -286,7 +286,7 @@
 	void test_script_helper_basic()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-helper.js"));
 		TS_ASSERT(man.LoadScript(L"simulation/helpers/test-helper.js"));
@@ -303,7 +303,7 @@
 	void test_script_global_helper()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-global-helper.js"));
 
@@ -319,7 +319,7 @@
 	void test_script_interface()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/interfaces/test-interface.js"));
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-interface.js"));
@@ -337,7 +337,7 @@
 	void test_script_errors()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		ScriptTestSetup(man.m_ScriptInterface);
 		man.LoadComponentTypes();
 
@@ -354,7 +354,7 @@
 	void test_script_entityID()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		ScriptTestSetup(man.m_ScriptInterface);
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-entityid.js"));
@@ -374,7 +374,7 @@
 	void test_script_QueryInterface()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-query.js"));
 
@@ -395,7 +395,7 @@
 	void test_script_AddEntity()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-addentity.js"));
 		TS_ASSERT(man.LoadScript(L"simulation/components/addentity/test-addentity.js"));
@@ -428,7 +428,7 @@
 	void test_script_AddLocalEntity()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-addentity.js"));
 		TS_ASSERT(man.LoadScript(L"simulation/components/addentity/test-addentity.js"));
@@ -461,7 +461,7 @@
 	void test_script_DestroyEntity()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-destroyentity.js"));
 
@@ -481,7 +481,7 @@
 	void test_script_messages()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-msg.js"));
 
@@ -514,7 +514,7 @@
 	void test_script_template()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-param.js"));
 
@@ -536,7 +536,7 @@
 	void test_script_template_readonly()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-param.js"));
 
@@ -558,7 +558,7 @@
 	void test_script_hotload()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-hotload1.js"));
@@ -594,7 +594,7 @@
 	void test_serialization()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2, ent3 = FIRST_LOCAL_ENTITY;
@@ -664,7 +664,7 @@
 		);
 
 		CSimContext context2;
-		CComponentManager man2(context2);
+		CComponentManager man2(context2, ScriptInterface::CreateRuntime());
 		man2.LoadComponentTypes();
 
 		TS_ASSERT(man2.QueryInterface(ent1, IID_Test1) == NULL);
@@ -683,7 +683,7 @@
 	void test_script_serialization()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		ScriptTestSetup(man.m_ScriptInterface);
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-serialize.js"));
@@ -754,7 +754,7 @@
 		TS_ASSERT(man.SerializeState(stateStream));
 
 		CSimContext context2;
-		CComponentManager man2(context2);
+		CComponentManager man2(context2, ScriptInterface::CreateRuntime());
 		man2.LoadComponentTypes();
 		TS_ASSERT(man2.LoadScript(L"simulation/components/test-serialize.js"));
 
@@ -771,7 +771,7 @@
 	void test_script_serialization_errors()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-serialize.js"));
 
@@ -789,7 +789,7 @@
 	void test_script_serialization_template()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-serialize.js"));
 		man.InitSystemEntity();
@@ -813,7 +813,7 @@
 		TS_ASSERT(man.SerializeState(stateStream));
 
 		CSimContext context2;
-		CComponentManager man2(context2);
+		CComponentManager man2(context2, ScriptInterface::CreateRuntime());
 		man2.LoadComponentTypes();
 		TS_ASSERT(man2.LoadScript(L"simulation/components/test-serialize.js"));
 
Index: source/simulation2/tests/test_Simulation2.h
===================================================================
--- source/simulation2/tests/test_Simulation2.h	(Revision 14461)
+++ source/simulation2/tests/test_Simulation2.h	(Arbeitskopie)
@@ -17,6 +17,7 @@
 
 #include "lib/self_test.h"
 
+#include "scriptinterface/ScriptInterface.h"
 #include "simulation2/Simulation2.h"
 #include "simulation2/MessageTypes.h"
 #include "simulation2/components/ICmpTest.h"
@@ -56,7 +57,7 @@
 
 	void test_AddEntity()
 	{
-		CSimulation2 sim(NULL, &m_Terrain);
+		CSimulation2 sim(NULL, ScriptInterface::CreateRuntime(), &m_Terrain);
 		TS_ASSERT(sim.LoadScripts(L"simulation/components/addentity/"));
 
 		sim.ResetState(true, true);
@@ -76,7 +77,7 @@
 
 	void test_DestroyEntity()
 	{
-		CSimulation2 sim(NULL, &m_Terrain);
+		CSimulation2 sim(NULL, ScriptInterface::CreateRuntime(), &m_Terrain);
 		TS_ASSERT(sim.LoadScripts(L"simulation/components/addentity/"));
 
 		sim.ResetState(true, true);
@@ -128,7 +129,7 @@
 
 	void test_hotload_scripts()
 	{
-		CSimulation2 sim(NULL, &m_Terrain);
+		CSimulation2 sim(NULL, ScriptInterface::CreateRuntime(), &m_Terrain);
 
 		TS_ASSERT_OK(CreateDirectories(DataDir()/"mods"/"_test.sim"/"simulation"/"components"/"hotload"/"", 0700));
 
Index: source/simulation2/tests/test_CmpTemplateManager.h
===================================================================
--- source/simulation2/tests/test_CmpTemplateManager.h	(Revision 14461)
+++ source/simulation2/tests/test_CmpTemplateManager.h	(Arbeitskopie)
@@ -52,7 +52,7 @@
 	void test_LoadTemplate()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2;
@@ -114,7 +114,7 @@
 	void test_LoadTemplate_scriptcache()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2;
@@ -152,7 +152,7 @@
 	void test_LoadTemplate_errors()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2;
@@ -184,7 +184,7 @@
 	void test_LoadTemplate_multiple()
 	{
 		CSimContext context;
-		CComponentManager man(context);
+		CComponentManager man(context, ScriptInterface::CreateRuntime());
 		man.LoadComponentTypes();
 
 		entity_id_t ent1 = 1, ent2 = 2;
@@ -243,7 +243,7 @@
 	void test_load_all_DISABLED() // disabled since it's a bit slow and noisy
 	{
 		CTerrain dummy;
-		CSimulation2 sim(NULL, &dummy);
+		CSimulation2 sim(NULL, ScriptInterface::CreateRuntime(), &dummy);
 		sim.LoadDefaultScripts();
 		sim.ResetState();
 
Index: source/simulation2/tests/test_Serializer.h
===================================================================
--- source/simulation2/tests/test_Serializer.h	(Revision 14461)
+++ source/simulation2/tests/test_Serializer.h	(Arbeitskopie)
@@ -644,7 +644,7 @@
 
 		CTerrain terrain;
 
-		CSimulation2 sim2(NULL, &terrain);
+		CSimulation2 sim2(NULL, ScriptInterface::CreateRuntime(), &terrain);
 		sim2.LoadDefaultScripts();
 		sim2.ResetState();
 
Index: source/simulation2/system/ComponentManager.cpp
===================================================================
--- source/simulation2/system/ComponentManager.cpp	(Revision 14461)
+++ source/simulation2/system/ComponentManager.cpp	(Arbeitskopie)
@@ -52,9 +52,9 @@
 	CScriptValRooted msg;
 };
 
-CComponentManager::CComponentManager(CSimContext& context, bool skipScriptFunctions) :
+CComponentManager::CComponentManager(CSimContext& context, shared_ptr<ScriptRuntime> rt, bool skipScriptFunctions) :
 	m_NextScriptComponentTypeId(CID__LastNative),
-	m_ScriptInterface("Engine", "Simulation", ScriptInterface::CreateRuntime(128*MiB)),
+	m_ScriptInterface("Engine", "Simulation", rt),
 	m_SimContext(context), m_CurrentlyHotloading(false)
 {
 	context.SetComponentManager(this);
@@ -143,9 +143,9 @@
 	return ok;
 }
 
-void CComponentManager::Script_RegisterComponentType(void* cbdata, int iid, std::string cname, CScriptVal ctor)
+void CComponentManager::Script_RegisterComponentType(ScriptInterface::CxPrivate* pCxPrivate, int iid, std::string cname, CScriptVal ctor)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	// Find the C++ component that wraps the interface
 	int cidWrapper = componentManager->GetScriptWrapper(iid);
@@ -294,9 +294,9 @@
 	}
 }
 
-void CComponentManager::Script_RegisterInterface(void* cbdata, std::string name)
+void CComponentManager::Script_RegisterInterface(ScriptInterface::CxPrivate* pCxPrivate, std::string name)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	std::map<std::string, InterfaceId>::iterator it = componentManager->m_InterfaceIdsByName.find(name);
 	if (it != componentManager->m_InterfaceIdsByName.end())
@@ -315,9 +315,9 @@
 	componentManager->m_ScriptInterface.SetGlobal(("IID_" + name).c_str(), (int)id);
 }
 
-void CComponentManager::Script_RegisterMessageType(void* cbdata, std::string name)
+void CComponentManager::Script_RegisterMessageType(ScriptInterface::CxPrivate* pCxPrivate, std::string name)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	std::map<std::string, MessageTypeId>::iterator it = componentManager->m_MessageTypeIdsByName.find(name);
 	if (it != componentManager->m_MessageTypeIdsByName.end())
@@ -335,25 +335,25 @@
 	componentManager->m_ScriptInterface.SetGlobal(("MT_" + name).c_str(), (int)id);
 }
 
-void CComponentManager::Script_RegisterGlobal(void* cbdata, std::string name, CScriptVal value)
+void CComponentManager::Script_RegisterGlobal(ScriptInterface::CxPrivate* pCxPrivate, std::string name, CScriptVal value)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	// Set the value, and accept duplicates only if hotloading (otherwise it's an error,
 	// in order to detect accidental duplicate definitions of globals)
 	componentManager->m_ScriptInterface.SetGlobal(name.c_str(), value, componentManager->m_CurrentlyHotloading);
 }
 
-IComponent* CComponentManager::Script_QueryInterface(void* cbdata, int ent, int iid)
+IComponent* CComponentManager::Script_QueryInterface(ScriptInterface::CxPrivate* pCxPrivate, int ent, int iid)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 	IComponent* component = componentManager->QueryInterface((entity_id_t)ent, iid);
 	return component;
 }
 
-std::vector<int> CComponentManager::Script_GetEntitiesWithInterface(void* cbdata, int iid)
+std::vector<int> CComponentManager::Script_GetEntitiesWithInterface(ScriptInterface::CxPrivate* pCxPrivate, int iid)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	std::vector<int> ret;
 	const InterfaceListUnordered& ents = componentManager->GetEntitiesWithInterfaceUnordered(iid);
@@ -364,9 +364,9 @@
 	return ret;
 }
 
-std::vector<IComponent*> CComponentManager::Script_GetComponentsWithInterface(void* cbdata, int iid)
+std::vector<IComponent*> CComponentManager::Script_GetComponentsWithInterface(ScriptInterface::CxPrivate* pCxPrivate, int iid)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	std::vector<IComponent*> ret;
 	InterfaceList ents = componentManager->GetEntitiesWithInterface(iid);
@@ -391,9 +391,9 @@
 	}
 }
 
-void CComponentManager::Script_PostMessage(void* cbdata, int ent, int mtid, CScriptVal data)
+void CComponentManager::Script_PostMessage(ScriptInterface::CxPrivate* pCxPrivate, int ent, int mtid, CScriptVal data)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	CMessage* msg = componentManager->ConstructMessage(mtid, data);
 	if (!msg)
@@ -404,9 +404,9 @@
 	delete msg;
 }
 
-void CComponentManager::Script_BroadcastMessage(void* cbdata, int mtid, CScriptVal data)
+void CComponentManager::Script_BroadcastMessage(ScriptInterface::CxPrivate* pCxPrivate, int mtid, CScriptVal data)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	CMessage* msg = componentManager->ConstructMessage(mtid, data);
 	if (!msg)
@@ -417,9 +417,9 @@
 	delete msg;
 }
 
-int CComponentManager::Script_AddEntity(void* cbdata, std::string templateName)
+int CComponentManager::Script_AddEntity(ScriptInterface::CxPrivate* pCxPrivate, std::string templateName)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	std::wstring name(templateName.begin(), templateName.end());
 	// TODO: should validate the string to make sure it doesn't contain scary characters
@@ -429,9 +429,9 @@
 	return (int)ent;
 }
 
-int CComponentManager::Script_AddLocalEntity(void* cbdata, std::string templateName)
+int CComponentManager::Script_AddLocalEntity(ScriptInterface::CxPrivate* pCxPrivate, std::string templateName)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	std::wstring name(templateName.begin(), templateName.end());
 	// TODO: should validate the string to make sure it doesn't contain scary characters
@@ -441,9 +441,9 @@
 	return (int)ent;
 }
 
-void CComponentManager::Script_DestroyEntity(void* cbdata, int ent)
+void CComponentManager::Script_DestroyEntity(ScriptInterface::CxPrivate* pCxPrivate, int ent)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	componentManager->DestroyComponentsSoon(ent);
 }
@@ -1001,19 +1001,19 @@
 	return schema;
 }
 
-CScriptVal CComponentManager::Script_ReadJSONFile(void* cbdata, std::wstring fileName)
+CScriptVal CComponentManager::Script_ReadJSONFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring fileName)
 {
-	return ReadJSONFile(cbdata, L"simulation/data", fileName);
+	return ReadJSONFile(pCxPrivate, L"simulation/data", fileName);
 }
 
-CScriptVal CComponentManager::Script_ReadCivJSONFile(void* cbdata, std::wstring fileName)
+CScriptVal CComponentManager::Script_ReadCivJSONFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring fileName)
 {
-	return ReadJSONFile(cbdata, L"civs", fileName);
+	return ReadJSONFile(pCxPrivate, L"civs", fileName);
 }
 
-CScriptVal CComponentManager::ReadJSONFile(void* cbdata, std::wstring filePath, std::wstring fileName)
+CScriptVal CComponentManager::ReadJSONFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filePath, std::wstring fileName)
 {
-	CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+	CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 
 	VfsPath path = VfsPath(filePath) / fileName;
 
@@ -1033,7 +1033,7 @@
 	return INFO::OK;
 }
 
-std::vector<std::string> CComponentManager::Script_FindJSONFiles(void* UNUSED(cbdata), std::wstring subPath, bool recursive)
+std::vector<std::string> CComponentManager::Script_FindJSONFiles(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring subPath, bool recursive)
 {
 	FindJSONFilesCallbackData cbData;
 	cbData.path = VfsPath(L"simulation/data/" + subPath + L"/");
Index: source/simulation2/system/ComponentManager.h
===================================================================
--- source/simulation2/system/ComponentManager.h	(Revision 14461)
+++ source/simulation2/system/ComponentManager.h	(Arbeitskopie)
@@ -78,7 +78,7 @@
 	};
 
 public:
-	CComponentManager(CSimContext&, bool skipScriptFunctions = false);
+	CComponentManager(CSimContext&, shared_ptr<ScriptRuntime> rt, bool skipScriptFunctions = false);
 	~CComponentManager();
 
 	void LoadComponentTypes();
@@ -242,23 +242,22 @@
 
 private:
 	// Implementations of functions exposed to scripts
-	static void Script_RegisterComponentType(void* cbdata, int iid, std::string cname, CScriptVal ctor);
-	static void Script_RegisterInterface(void* cbdata, std::string name);
-	static void Script_RegisterMessageType(void* cbdata, std::string name);
-	static void Script_RegisterGlobal(void* cbdata, std::string name, CScriptVal value);
-	static IComponent* Script_QueryInterface(void* cbdata, int ent, int iid);
-	static std::vector<int> Script_GetEntitiesWithInterface(void* cbdata, int iid);
-	static std::vector<IComponent*> Script_GetComponentsWithInterface(void* cbdata, int iid);
-	static void Script_PostMessage(void* cbdata, int ent, int mtid, CScriptVal data);
-	static void Script_BroadcastMessage(void* cbdata, int mtid, CScriptVal data);
-	static int Script_AddEntity(void* cbdata, std::string templateName);
-	static int Script_AddLocalEntity(void* cbdata, std::string templateName);
-	static void Script_DestroyEntity(void* cbdata, int ent);
-	static CScriptVal Script_ReadJSONFile(void* cbdata, std::wstring fileName);
-	static CScriptVal Script_ReadCivJSONFile(void* cbdata, std::wstring fileName);
-	static std::vector<std::string> Script_FindJSONFiles(void* cbdata, std::wstring subPath, bool recursive);
-
-	static CScriptVal ReadJSONFile(void *cbdata, std::wstring filePath, std::wstring fileName);
+	static void Script_RegisterComponentType(ScriptInterface::CxPrivate* pCxPrivate, int iid, std::string cname, CScriptVal ctor);
+	static void Script_RegisterInterface(ScriptInterface::CxPrivate* pCxPrivate, std::string name);
+	static void Script_RegisterMessageType(ScriptInterface::CxPrivate* pCxPrivate, std::string name);
+	static void Script_RegisterGlobal(ScriptInterface::CxPrivate* pCxPrivate, std::string name, CScriptVal value);
+	static IComponent* Script_QueryInterface(ScriptInterface::CxPrivate* pCxPrivate, int ent, int iid);
+	static std::vector<int> Script_GetEntitiesWithInterface(ScriptInterface::CxPrivate* pCxPrivate, int iid);
+	static std::vector<IComponent*> Script_GetComponentsWithInterface(ScriptInterface::CxPrivate* pCxPrivate, int iid);
+	static void Script_PostMessage(ScriptInterface::CxPrivate* pCxPrivate, int ent, int mtid, CScriptVal data);
+	static void Script_BroadcastMessage(ScriptInterface::CxPrivate* pCxPrivate, int mtid, CScriptVal data);
+	static int Script_AddEntity(ScriptInterface::CxPrivate* pCxPrivate, std::string templateName);
+	static int Script_AddLocalEntity(ScriptInterface::CxPrivate* pCxPrivate, std::string templateName);
+	static void Script_DestroyEntity(ScriptInterface::CxPrivate* pCxPrivate, int ent);
+	static CScriptVal Script_ReadJSONFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring fileName);
+	static CScriptVal Script_ReadCivJSONFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring fileName);
+	static std::vector<std::string> Script_FindJSONFiles(ScriptInterface::CxPrivate* pCxPrivate, std::wstring subPath, bool recursive);
+	static CScriptVal ReadJSONFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filePath, std::wstring fileName);
 	
 	// callback function to handle recursively finding files in a directory
 	static Status FindJSONFilesCallback(const VfsPath&, const CFileInfo&, const uintptr_t);
Index: source/simulation2/system/ComponentTest.h
===================================================================
--- source/simulation2/system/ComponentTest.h	(Revision 14461)
+++ source/simulation2/system/ComponentTest.h	(Arbeitskopie)
@@ -53,7 +53,7 @@
 
 public:
 	ComponentTestHelper() :
-		m_Context(), m_ComponentManager(m_Context), m_Cmp(NULL)
+		m_Context(), m_ComponentManager(m_Context, ScriptInterface::CreateRuntime()), m_Cmp(NULL)
 	{
 		m_ComponentManager.LoadComponentTypes();
 	}
Index: source/simulation2/components/CCmpAIManager.cpp
===================================================================
--- source/simulation2/components/CCmpAIManager.cpp	(Revision 14461)
+++ source/simulation2/components/CCmpAIManager.cpp	(Arbeitskopie)
@@ -270,15 +270,17 @@
 		return true;
 	}
 	
-	static void IncludeModule(void* cbdata, std::wstring name)
+	static void IncludeModule(ScriptInterface::CxPrivate* pCxPrivate, std::wstring name)
 	{
-		CAIWorker* self = static_cast<CAIWorker*> (cbdata);
+		ENSURE(pCxPrivate->pCBData);
+		CAIWorker* self = static_cast<CAIWorker*> (pCxPrivate->pCBData);
 		self->LoadScripts(name);
 	}
 
-	static void PostCommand(void* cbdata, int playerid, CScriptValRooted cmd)
+	static void PostCommand(ScriptInterface::CxPrivate* pCxPrivate, int playerid, CScriptValRooted cmd)
 	{
-		CAIWorker* self = static_cast<CAIWorker*> (cbdata);
+		ENSURE(pCxPrivate->pCBData);
+		CAIWorker* self = static_cast<CAIWorker*> (pCxPrivate->pCBData);
 		self->PostCommand(playerid, cmd);
 	}
 	
@@ -296,30 +298,20 @@
 		LOGERROR(L"Invalid playerid in PostCommand!");	
 	}
 	// The next two ought to be implmeneted someday but for now as it returns "null" it can't
-	static void DumpHeap(void* cbdata)
+	static void DumpHeap(ScriptInterface::CxPrivate* pCxPrivate)
 	{
-		if (cbdata == NULL) {
-			debug_warn(L"Warning: the shared component has asked for DumpHeap. Ignoring.");
-			return;
-		}
-		CAIWorker* self = static_cast<CAIWorker*> (cbdata);
-		self->m_ScriptInterface->DumpHeap();
+		pCxPrivate->pScriptInterface->DumpHeap();
 	}
-	static void ForceGC(void* cbdata)
+	static void ForceGC(ScriptInterface::CxPrivate* pCxPrivate)
 	{
-		if (cbdata == NULL) {
-			debug_warn(L"Warning: the shared component has asked for ForceGC. Ignoring.");
-			return;
-		}
-		CAIWorker* self = static_cast<CAIWorker*> (cbdata);
 		PROFILE3("AI compute GC");
-		JS_GC(self->m_ScriptInterface->GetContext());
+		JS_GC(pCxPrivate->pScriptInterface->GetContext());
 	}
 	
 	/**
 	 * Debug function for AI scripts to dump 2D array data (e.g. terrain tile weights).
 	 */
-	static void DumpImage(void* UNUSED(cbdata), std::wstring name, std::vector<u32> data, u32 w, u32 h, u32 max)
+	static void DumpImage(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring name, std::vector<u32> data, u32 w, u32 h, u32 max)
 	{
 		// TODO: this is totally not threadsafe.
 		VfsPath filename = L"screenshots/aidump/" + name;
@@ -763,7 +755,7 @@
 		}
 
 		// Run GC if we are about to overflow
-		if (JS_GetGCParameter(m_ScriptInterface->GetRuntime(), JSGC_BYTES) > 33000000)
+		if (JS_GetGCParameter(m_ScriptInterface->GetJSRuntime(), JSGC_BYTES) > 33000000)
 		{
 			PROFILE3("AI compute GC");
 
Index: source/simulation2/components/tests/test_Pathfinder.h
===================================================================
--- source/simulation2/components/tests/test_Pathfinder.h	(Revision 14461)
+++ source/simulation2/components/tests/test_Pathfinder.h	(Arbeitskopie)
@@ -61,7 +61,7 @@
 	{
 		CTerrain terrain;
 
-		CSimulation2 sim2(NULL, &terrain);
+		CSimulation2 sim2(NULL, ScriptInterface::CreateRuntime(), &terrain);
 		sim2.LoadDefaultScripts();
 		sim2.ResetState();
 
@@ -114,7 +114,7 @@
 		CTerrain terrain;
 		terrain.Initialize(5, NULL);
 
-		CSimulation2 sim2(NULL, &terrain);
+		CSimulation2 sim2(NULL, ScriptInterface::CreateRuntime(), &terrain);
 		sim2.LoadDefaultScripts();
 		sim2.ResetState();
 
Index: source/simulation2/components/tests/test_scripts.h
===================================================================
--- source/simulation2/components/tests/test_scripts.h	(Revision 14461)
+++ source/simulation2/components/tests/test_scripts.h	(Arbeitskopie)
@@ -43,15 +43,15 @@
 		TSM_ASSERT(L"Running script "+pathname.string(), scriptInterface.LoadScript(pathname, content));
 	}
 
-	static void Script_LoadComponentScript(void* cbdata, VfsPath pathname)
+	static void Script_LoadComponentScript(ScriptInterface::CxPrivate* pCxPrivate, VfsPath pathname)
 	{
-		CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+		CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 		TS_ASSERT(componentManager->LoadScript(VfsPath(L"simulation/components") / pathname));
 	}
 
-	static void Script_LoadHelperScript(void* cbdata, VfsPath pathname)
+	static void Script_LoadHelperScript(ScriptInterface::CxPrivate* pCxPrivate, VfsPath pathname)
 	{
-		CComponentManager* componentManager = static_cast<CComponentManager*> (cbdata);
+		CComponentManager* componentManager = static_cast<CComponentManager*> (pCxPrivate->pCBData);
 		TS_ASSERT(componentManager->LoadScript(VfsPath(L"simulation/helpers") / pathname));
 	}
 
@@ -68,7 +68,7 @@
 		for (size_t i = 0; i < paths.size(); ++i)
 		{
 			CSimContext context;
-			CComponentManager componentManager(context, true);
+			CComponentManager componentManager(context, ScriptInterface::CreateRuntime(), true);
 
 			ScriptTestSetup(componentManager.GetScriptInterface());
 
Index: source/simulation2/Simulation2.cpp
===================================================================
--- source/simulation2/Simulation2.cpp	(Revision 14461)
+++ source/simulation2/Simulation2.cpp	(Arbeitskopie)
@@ -59,8 +59,8 @@
 class CSimulation2Impl
 {
 public:
-	CSimulation2Impl(CUnitManager* unitManager, CTerrain* terrain) :
-		m_SimContext(), m_ComponentManager(m_SimContext),
+	CSimulation2Impl(CUnitManager* unitManager, shared_ptr<ScriptRuntime> rt, CTerrain* terrain) :
+		m_SimContext(), m_ComponentManager(m_SimContext, rt),
 		m_EnableOOSLog(false), m_EnableSerializationTest(false)
 	{
 		m_SimContext.m_UnitManager = unitManager;
@@ -376,7 +376,7 @@
 		CTerrain secondaryTerrain;
 		CSimContext secondaryContext;
 		secondaryContext.m_Terrain = &secondaryTerrain;
-		CComponentManager secondaryComponentManager(secondaryContext);
+		CComponentManager secondaryComponentManager(secondaryContext, m_ComponentManager.GetScriptInterface().GetRuntime());
 		secondaryComponentManager.LoadComponentTypes();
 		ENSURE(LoadDefaultScripts(secondaryComponentManager, NULL));
 		ResetComponentState(secondaryComponentManager, false, false);
@@ -565,8 +565,8 @@
 
 ////////////////////////////////////////////////////////////////
 
-CSimulation2::CSimulation2(CUnitManager* unitManager, CTerrain* terrain) :
-	m(new CSimulation2Impl(unitManager, terrain))
+CSimulation2::CSimulation2(CUnitManager* unitManager, shared_ptr<ScriptRuntime> rt, CTerrain* terrain) :
+	m(new CSimulation2Impl(unitManager, rt, terrain))
 {
 }
 
